Index: trunk/tools/bootloader_tsar/boot.c
===================================================================
--- trunk/tools/bootloader_tsar/boot.c	(revision 1)
+++ trunk/tools/bootloader_tsar/boot.c	(revision 6)
@@ -421,24 +458,126 @@
             irq->port , device_type_str( irq->dev_type ) , irq->channel , irq->is_rx );
 #endif
-
-                }
-            }
-
-            // Initialize array of irq descriptors for PIC
-            if (device->type == DEV_TYPE_PIC) 
-            {
-                for (irq_id = 0; irq_id < CONFIG_MAX_IRQS_PER_PIC; irq_id++)
-                {
-                    boot_dev->irq[irq_id].valid  = 0;
-                }
-
-                for (irq = &irq_base[device->irq_offset];
-                     irq < &irq_base[device->irq_offset + device->irqs];
-                     irq++)
-                {
-                    boot_dev->irq[irq->port].valid    = 1;
-                    boot_dev->irq[irq->port].dev_type = irq->dev_type;
-                    boot_dev->irq[irq->port].channel  = irq->channel;
-                    boot_dev->irq[irq->port].is_rx    = irq->is_rx;
+            }
+        }
+    }
+
+    // initialize number of external peripherals
+    boot_info->ext_dev_nr = device_id;
+
+    // Initialize cluster specific resources
+    boot_info->cxy  = my_cluster->cxy;
+
+#if DEBUG_BOOT_INFO
+boot_printf("\n[BOOT INFO] %s : cores in cluster %x\n", __FUNCTION__ );
+#endif
+
+    // Initialize array of core descriptors
+    core_id = 0;
+    for (core = &core_base[my_cluster->core_offset];
+         core < &core_base[my_cluster->core_offset + my_cluster->cores];
+         core++ )
+    {
+        boot_info->core[core_id].gid = (gid_t)core->gid;
+        boot_info->core[core_id].lid = (lid_t)core->lid; 
+        boot_info->core[core_id].cxy = (cxy_t)core->cxy;
+
+#if DEBUG_BOOT_INFO
+boot_printf("  - core_gid = %x : cxy = %x / lid = %d\n", 
+            core->gid , core->cxy , core->lid );
+#endif
+        core_id++;
+    }
+
+    // Initialize number of cores in my_cluster
+    boot_info->cores_nr = core_id;
+
+    // loop on all peripherals in my_cluster to initialise
+    // boot_info array of internal peripherals in my_cluster
+
+#if DEBUG_BOOT_INFO
+boot_printf("\n[BOOT INFO] %s : internal peripherals in cluster %x\n", __FUNCTION__ );
+#endif
+
+    device_id = 0;
+    for (device = &device_base[my_cluster->device_offset];
+         device < &device_base[my_cluster->device_offset + my_cluster->devices];
+         device++ )
+    {
+        // initialise one entry for each internal peripheral
+        if( (device->type == DEV_TYPE_RAM_SCL) ||
+            (device->type == DEV_TYPE_ICU_XCU) ||
+            (device->type == DEV_TYPE_MMC_TSR) ||
+            (device->type == DEV_TYPE_DMA_SCL) ) 
+        {
+            boot_dev = &boot_info->int_dev[device_id];
+
+            boot_dev->type     = device->type;
+            boot_dev->base     = device->base;
+            boot_dev->size     = device->size;
+            boot_dev->channels = device->channels;
+            boot_dev->param0   = device->arg0;    
+            boot_dev->param1   = device->arg1;    
+            boot_dev->param2   = device->arg2;    
+            boot_dev->param3   = device->arg3;    
+            boot_dev->irqs     = device->irqs; 
+   
+            device_id++;
+        }
+
+#if DEBUG_BOOT_INFO
+boot_printf("  - %s : base = %l / size = %l / channels = %d / irqs = %d\n",
+            device_type_str( device->type ) , device->base , device->size ,
+            device->channels , device->irqs );   
+#endif
+
+        // Initialize information about physical memory in cluster
+        if (device->type == DEV_TYPE_RAM_SCL)
+        {
+            // Compute total number of physical memory pages in cluster
+            boot_info->pages_nr = device->size >> CONFIG_PPM_PAGE_SHIFT;
+
+            // Get the last address allocated for the kernel segments
+            uint32_t end;
+            if( boot_info->kernel_code_end > boot_info->kernel_data_end )
+            {
+                end = boot_info->kernel_code_end;
+            }
+            else
+            {
+                end = boot_info->kernel_data_end;
+            }
+                
+            // Compute the number of pages allocated for the kernel.
+            if( (end & CONFIG_PPM_PAGE_MASK) == 0 )
+            {
+                boot_info->pages_offset = end >> CONFIG_PPM_PAGE_SHIFT;
+            }
+            else
+            {
+                boot_info->pages_offset = (end >> CONFIG_PPM_PAGE_SHIFT) + 1;
+            }
+
+#if DEBUG_BOOT_INFO
+boot_printf("    . physical memory : %x pages / first free page = %x\n",
+            boot_info->pages_nr , boot_info->pages_offset );
+#endif
+        }
+            
+        // Initialize array of irq descriptors for XCU 
+        if (device->type == DEV_TYPE_ICU_XCU) 
+        {
+            for (irq_id = 0; irq_id < CONFIG_MAX_HWIS_PER_ICU; irq_id++)
+            {
+                boot_dev->irq[irq_id].valid  = 0;
+            }
+
+            for (irq = &irq_base[device->irq_offset];
+                 irq < &irq_base[device->irq_offset + device->irqs];
+                 irq++)
+            {
+                boot_dev->irq[irq->port].valid    = 1;
+                boot_dev->irq[irq->port].dev_type = irq->dev_type;
+                boot_dev->irq[irq->port].channel  = irq->channel;
+                boot_dev->irq[irq->port].is_rx    = irq->is_rx;
 
 #if DEBUG_BOOT_INFO
@@ -447,22 +586,21 @@
 #endif
 
-                }
             }
         }
-
-#if DEBUG_BOOT_INFO
-boot_printf("  - ram : number of pages = %x / first free page = %x\n",
-            boot_info->pages_nr , boot_info->pages_offset );
-#endif
-
-    }
+    }
+
+    // initialize number of internal peripherals in my_cluster
+    boot_info->int_dev_nr = device_id;
+
+    // set boot_info signature
+    boot_info->signature = BOOT_INFO_SIGNATURE;
+
 } // boot_info_init()
 
-/****************************************************************************
- * This function is executed by all cores in order to check their           *
- * local boot_info_t structure.                                             *
- * @ boot_info  : pointer to local 'boot_info_t' structure to be checked.   *
- * @ lid        : core local identifier, index the core descriptor table.   *
- ****************************************************************************/
+/***********************************************************************************
+ * This function check the local boot_info_t structure for a given core.
+ * @ boot_info  : pointer to local 'boot_info_t' structure to be checked.
+ * @ lid        : core local identifier, index the core descriptor table.
+ **********************************************************************************/
 static void boot_check_core( boot_info_t * boot_info, 
                              lid_t         lid)
@@ -490,20 +628,16 @@
 } // boot_check_core()
 
-/****************************************************************************
- * This function is called by the bscpu to activate all other CP0s.         *
+/*********************************************************************************
+ * This function is called by CP0 in cluster(0,0) to activate all other CP0s.
  * It returns the number of CP0s actually activated.
- ****************************************************************************/
-static uint32_t boot_wake_cp0()
+ ********************************************************************************/
+static uint32_t boot_wake_all_cp0s()
 {
-    archinfo_header_t*  header;         /* Pointer on ARCHINFO header.      */
-    archinfo_cluster_t* cluster_base;   /* Pointer on ARCHINFO cluster 
-                                           base.                            */ 
-    archinfo_cluster_t* cluster;        /* Iterator for waking CP0 loop.    */
-    archinfo_device_t*  device_base;    /* Pointer on ARCHINFO peripheral 
-                                           device base.                     */
-    archinfo_device_t*  device;         /* Iterator for finding XICU device 
-                                           loop.                            */
-
-    uint32_t            cp0_nb = 0;     /* Number of CP0 woken up.          */
+    archinfo_header_t*  header;         // Pointer on ARCHINFO header
+    archinfo_cluster_t* cluster_base;   // Pointer on ARCHINFO clusters base
+    archinfo_cluster_t* cluster;        // Iterator for loop on clusters
+    archinfo_device_t*  device_base;    // Pointer on ARCHINFO devices base
+    archinfo_device_t*  device;         // Iterator for loop on devices
+    uint32_t            cp0_nb = 0;     // CP0s counter
 
     header       = (archinfo_header_t*)ARCHINFO_BASE;
@@ -528,12 +662,17 @@
             continue;
 
-        // Look for the XICU device associated to the CP0 of this cluster 
-        // then send an WTI to it in order to wake it up. 
+        // search XICU device associated to CP0, and send a WTI to activate it 
         for (device = &device_base[cluster->device_offset];
              device < &device_base[cluster->device_offset + cluster->devices];
              device++)
         {
-            if (device->type == DEV_TYPE_XCU)
-            {
+            if (device->type == DEV_TYPE_ICU_XCU)
+            {
+
+#if DEBUG_BOOT_WAKUP
+boot_printf("\n[BOOT] core[%x][0] activated at cycle %d\n",
+            cluster->cxy , boot_get_proctime );
+#endif
+
                 boot_remote_sw((xptr_t)device->base, (uint32_t)boot_entry);
                 cp0_nb++;
@@ -545,227 +684,182 @@
 } // boot_wake_cp0()
 
-/****************************************************************************
- * This function is called by all CP0 to activate all local CPi cores.      *
- * @ boot_info  : pointer to local 'boot_info_t' structure, used to find    *
- *                the XICU device associated with local CPi base addresses. *
- ****************************************************************************/
-static void boot_wake_local_cores(boot_info_t* boot_info)
+/*********************************************************************************
+ * This function is called by all CP0 to activate all local CPi cores. 
+ * @ boot_info  : pointer to local 'boot_info_t' structure, used to find
+ *                the XICU device associated with local CPi base addresses.
+ *********************************************************************************/
+static void boot_wake_local_cores(boot_info_t * boot_info)
 {
-    boot_device_t*  device;         // Iterator on devices
-    unsigned int    core_id;        // Iterator on cores
+    boot_device_t *  device;         // Iterator on devices
+    unsigned int     core_id;        // Iterator on cores
 
     // loop on devices to find XCU
-    for (device = &boot_info->dev[0];
-         device < &boot_info->dev[boot_info->devices_nr];
+    for (device = &boot_info->int_dev[0];
+         device < &boot_info->int_dev[boot_info->int_dev_nr];
          device++)
     {
-        if (device->type == DEV_TYPE_XCU)
+        if (device->type == DEV_TYPE_ICU_XCU)
         {
             // loop on cores
             for (core_id = 1; core_id < boot_info->cores_nr; core_id++)
+            {
+
+#if DEBUG_BOOT_WAKUP
+boot_printf("\n[BOOT] core[%x][%d] activated at cycle %d\n",
+             boot_info->cxy , core_id , boot_get_proctime() );
+#endif
                 boot_remote_sw((xptr_t) (device->base + (core_id << 2)),
                                (uint32_t)boot_entry); 
+            }
         }
     }
 } // boot_wake_local_cores()
 
-/****************************************************************************
- *                               API functions.                             *
- ****************************************************************************/
-
-/****************************************************************************
+
+/*********************************************************************************
  * This main function of the boot-loader is called by the  boot_entry()  
  * function, and executed by all cores. 
  * The arguments values are computed by the boot_entry code.
- * @ lid    : core local identifier in its cluster,
+ * @ lid    : core local identifier,
  * @ cxy    : cluster identifier,
- ****************************************************************************/
+ *********************************************************************************/
 void boot_loader( lid_t lid, 
                   cxy_t cxy )
 {
-    boot_info_t * boot_info;   // Pointer on local boot_info_t structure
-    uint32_t     local_count;  // Number of cores expected in local barrier                                  */
+    boot_info_t * boot_info;       // pointer on local boot_info_t structure
 
     if (lid == 0) 
     {
-        /**************************************
-         * PHASE ONE: only bscpu executes it. *
-         **************************************/
+        /****************************************************
+         * PHASE A : only CP0 in boot cluster executes it 
+         ***************************************************/
         if (cxy == BOOT_CORE_CXY)
         {
-            boot_printf("\n[BOOT] Starting on core[%d] in cluster %x at cycle %d\n",
-                        lid, cxy, boot_get_proctime());
+            boot_printf("\n[BOOT] core[%x][%d] enters at cycle %d\n",
+                        cxy , lid , boot_get_proctime() );
 
             // Initialize IOC driver 
             if      (USE_IOC_BDV) boot_bdv_init();
             else if (USE_IOC_HBA) boot_hba_init();
-            /*
-            else if (USE_IOC_SDC) boot_sdc_init();
-            else if (USE_IOC_SPI) boot_spi_init();
-            */
+            // else if (USE_IOC_SDC) boot_sdc_init();
+            // else if (USE_IOC_SPI) boot_spi_init();
             else if (!USE_IOC_RDK)
             {
-                boot_printf("\n[BOOT ERROR] boot_loader(): "
-                            "No IOC driver\n"
-                           );
+                boot_printf("\n[BOOT ERROR] in %s : no IOC driver\n");
                 boot_exit();
             }
 
-            // Initialize simplified version of FAT32. 
+            // Initialize FAT32. 
             boot_fat32_init();
+
+            // Load the 'kernel.elf' file into memory from IOC, and set   
+            // the global variables defining the kernel layout      
+            boot_kernel_load();
+
+            boot_printf("\n[BOOT] core[%x][%d] loaded kernel at cycle %d\n",
+                        cxy , lid , boot_get_proctime() );
 
             // Load the arch_info.bin file into memory.
             boot_archinfo_load();
 
-            // Load the 'kernel.elf' file into memory.
-            boot_kernel_load();
-
-            // Get local 'boot_info_t' structure base address.
+            // Get local boot_info_t structure base address.
             // It is the first structure in the .kdata segment. 
-            boot_info = (boot_info_t*)(KERN_IMG_TMP_BASE + kdata_base);
-
-            // Signature problem, abort program !!!
+            boot_info = (boot_info_t *)seg_kdata_base;
+
+            // Initialize local boot_info_t structure.
+            boot_info_init( boot_info , cxy );
+
+            // check boot_info signature
             if (boot_info->signature != BOOT_INFO_SIGNATURE)
             {
-                boot_printf("\n[BOOT] boot_loader(): "
-                            "boot_info signature should be %x\n",
-                            BOOT_INFO_SIGNATURE);
+                boot_printf("\n[BOOT ERROR] in %s reported by core[%x][%d]\n"
+                            "  illegal boot_info signature / should be %x\n",
+                            __FUNCTION__ , cxy , lid , BOOT_INFO_SIGNATURE );
                 boot_exit();
             }
 
-            // Initialize local 'boot_info_t' structure.
-            boot_printf("\n[BOOT] boot_loader(): "
-                        "Initializing the local boot_info_t structure "
-                        "at cycle %d\n",
-                        boot_get_proctime());
-
-            boot_info_init(boot_info, cxy);
+            boot_printf("\n[BOOT] core[%x][%d] loaded boot_info at cycle %d\n",
+                        cxy , lid , boot_get_proctime() );
 
             // Check core information.
             boot_check_core(boot_info, lid);
 
-            // Set the barrier.
-            boot_cluster_ready = 0;
-
-            // Activate other CP0s
-            boot_printf("\n[BOOT] boot_loader(): "
-                        "Waking other CP0 up at cycle %d\n",
-                        boot_get_proctime());
-
-            global_count = boot_wake_cp0();
-
-            // Wait until all CP0s ready to enter kernel.
-            boot_printf("\n[BOOT] boot_loader(): "
-                        "Waiting for other %d CP0 at cycle %d\n",
-                        global_count, boot_get_proctime());
-
-            boot_barrier(XPTR(BOOT_CORE_CXY, &global_barrier), 
-                         global_count);
-
-            // activate other local cores of the boot cluster.
-            local_barrier = 0;
-            boot_printf("\n[BOOT] boot_loader(): "
-                        "Waking other CPi up at cycle %d\n",
-                        boot_get_proctime());
-
-            boot_wake_local_cores(boot_info);
-
-            // Wait until all other local cores are ready 
-            boot_printf("\n[BOOT] boot_loader(): "
-                        "Waiting for other %d CPi at cycle %d\n",
-                        boot_info->cores_nr - 1, boot_get_proctime());
-
-            local_count = boot_info->cores_nr - 1;
-            while (local_barrier != local_count);
-
-            // Move the local kernel image at address 0x0 (erase preloader code).
-            boot_printf("\n[BOOT] boot_loader(): "
-                        "Moving the kernel image and erasing the preloader"
-                        "at cycle %d\n",
-                        boot_get_proctime());
-
-            // ktext segment.
-            boot_memcpy((void*)ktext_base,
-                        (void*)(KERN_IMG_TMP_BASE + ktext_base),
-                        ktext_end - ktext_base);
-
-            // kdata segment.
-            boot_memcpy((void*)kdata_base,
-                        (void*)(KERN_IMG_TMP_BASE + kdata_base),
-                        kdata_end - kdata_base);
-            
-            // activate other local cores.
-            boot_cluster_ready = 1;
-            boot_printf("\n[BOOT] boot_loader(): "
-                        "Everything is set, jumping to the kernel "
-                        "at cycle %d\n",
-                        boot_get_proctime());
+            // Activate other CP0s / get number of active CP0s
+            active_cp0s_nr = boot_wake_all_cp0s() + 1;
+
+            // Wait until all clusters (i.e all CP0s) ready to enter kernel.
+            boot_remote_barrier( XPTR( BOOT_CORE_CXY , &global_barrier ) ,
+                                 active_cp0s_nr );
+
+            // activate other local cores
+            boot_wake_local_cores( boot_info );
+
+            // Wait until all local cores in cluster ready
+            boot_remote_barrier( XPTR( cxy , &local_barrier ) , 
+                                 boot_info->cores_nr );
         }
-        /****************************************************
-         * PHASE TWO: all CP0s other than bscpu execute it. *
-         ****************************************************/
+        /******************************************************************
+         * PHASE B : all CP0s other than CP0 in boot cluster execute it
+         *****************************************************************/
         else
         {
-            /* 
-             * Note: at this point, we cannot access the global variables of
-             * this boot code since all the address extension registers for 
-             * DATA are pointing to their local cluster in order to have 
-             * access to the local stack and execute this C code. 
-             * However, all the address extension registers for INSTRUCTIONS 
-             * are still pointing to the boot cluster, thus we can access 
-             * and call functions defined in the boot code, for example 
-             * boot_remote_memcpy().
-             */
-
-            // Copy the boot-loader binary code 'boot.elf' into the local memory
-            boot_remote_memcpy(XPTR(cxy,           BOOT_BASE),
-                               XPTR(BOOT_CORE_CXY, BOOT_BASE),
-                               (unsigned int)BOOT_MAX_SIZE);
-
-            /*
-             * Note: from now on, it is safe to refer to the boot code global variables 
-             * such as the base address and size of the kernel segments.
-             */
-
-            // switch to the INSTRUCTION local memory space,  
-            // to avoid contention at the boot cluster.
+            // at this point, all INSTRUCTION address extension registers
+            // point on cluster(0,0), but the DATA extension registers point
+            // already on the local cluster to use the local stack. 
+            // To access the bootloader global variables we must first copy
+            // the boot code (data and instructions) in the local cluster.
+            boot_remote_memcpy( XPTR( cxy           , BOOT_BASE ),
+                                XPTR( BOOT_CORE_CXY , BOOT_BASE ),
+                                BOOT_MAX_SIZE );
+
+            // from now, it is safe to refer to the boot code global variables 
+            boot_printf("\n[BOOT] core[%x][%d] replicated boot code at cycle %d\n",
+                        cxy , lid , boot_get_proctime() );
+
+            // switch to the INSTRUCTION local memory space, to avoid contention.
             asm volatile("mtc2  %0, $25" :: "r"(cxy));
 
-            // Copy the 'arch_info.bin' file into the local memory.
+            // Copy the arch_info.bin file into the local memory.
             boot_remote_memcpy(XPTR(cxy,           ARCHINFO_BASE),
                                XPTR(BOOT_CORE_CXY, ARCHINFO_BASE),
-                               (unsigned int)ARCHINFO_MAX_SIZE);
-
-            // Copy the kernel image into local memory at address 0x0.
-            // ktext segment.
-            boot_remote_memcpy(XPTR(cxy, ktext_base),
-                               XPTR(BOOT_CORE_CXY, KERN_IMG_TMP_BASE + ktext_base),
-                               ktext_end - ktext_base);
-            // kdata segment.
-            boot_remote_memcpy(XPTR(cxy, kdata_base),
-                               XPTR(BOOT_CORE_CXY, KERN_IMG_TMP_BASE + kdata_base),
-                               kdata_end - kdata_base);
-
-            // Get local 'boot_info_t' structure base address.
-            // This is the first structure in the kdata segment.
-            boot_info = (boot_info_t*)kdata_base;
+                               ARCHINFO_MAX_SIZE );
+
+            boot_printf("\n[BOOT] core[%x][%d] replicated arch_info at cycle %d\n",
+                        cxy , lid , boot_get_proctime() );
+
+            // Copy the kcode segment into local memory 
+            boot_remote_memcpy( XPTR( cxy           , seg_kcode_base ),
+                                XPTR( BOOT_CORE_CXY , seg_kcode_base ),
+                                seg_kcode_size );
+
+            // Copy the kdata segment into local memory
+            boot_remote_memcpy( XPTR( cxy           , seg_kdata_base ),
+                                XPTR( BOOT_CORE_CXY , seg_kdata_base ),
+                                seg_kdata_size );
+
+            boot_printf("\n[BOOT] core[%x][%d] replicated kernel code at cycle %d\n",
+                        cxy , lid , boot_get_proctime() );
+
+            // Get local boot_info_t structure base address.
+            boot_info = (boot_info_t*)seg_kdata_base;
 
             // Initialize local boot_info_t structure.
-            boot_info_init(boot_info, cxy);
+            boot_info_init( boot_info , cxy );
 
             // Check core information.
-            boot_check_core(boot_info, lid);
-
-            // Activateall other local CPi cores in this cluster.
-            local_barrier = 0;
-            boot_wake_local_cores(boot_info);
-
-            // Waiting until all other local cores ready
-            local_count = boot_info->cores_nr - 1;
-            while (local_barrier != local_count);
-
-            // All cores in this cluster are ready to enter kernel.
-            boot_barrier(XPTR(BOOT_CORE_CXY, &global_barrier), 
-                         global_count);
+            boot_check_core( boot_info , lid );
+
+            // get number of active clusters from BOOT_CORE cluster
+            uint32_t count = boot_remote_lw( XPTR( BOOT_CORE_CXY , &active_cp0s_nr ) );
+
+            // Wait until all clusters (i.e all CP0s) ready to enter kernel
+            boot_remote_barrier( XPTR( BOOT_CORE_CXY , &global_barrier ) , count );
+
+            // activate other local cores
+            boot_wake_local_cores( boot_info );
+
+            // Wait until all local cores in cluster ready
+            boot_remote_barrier( XPTR( cxy , &local_barrier ) , 
+                                 boot_info->cores_nr );
         }
     }
@@ -773,36 +867,38 @@
     {
         /***************************************************************
-         * PHASE THREE: all non CP0 cores in all clusters execute it.  *
+         * PHASE C: all non CP0 cores in all clusters execute it
          **************************************************************/
 
-        if (cxy == BOOT_CORE_CXY)  // boot cluster only
-        {
-            // Report to the local CP0 that CPi is ready
-            boot_atomic_add((int32_t*)&local_barrier, 1);
-
-            // wait completion of kernel image move in  boot cluster
-            while (boot_cluster_ready != 1);
-
-            // Check core information
-            boot_info = (boot_info_t*)kdata_base;
-            boot_check_core(boot_info, lid);
-        }
-        else                      // other clusters
-        {
-            // Switch to the INSTRUCTIONS local memory space 
-            // to avoid contention at the boot cluster.
-            asm volatile("mtc2  %0, $25" :: "r"(cxy));
-
-            // Report to the local CP0 that CPi is ready
-            boot_atomic_add((int32_t*)&local_barrier, 1);
-
-            // Check core information
-            boot_info = (boot_info_t*)kdata_base;
-            boot_check_core(boot_info, lid);
-        }
-    }
-
-    // Jump to the kernel code. 
-    asm volatile("jr   %0" :: "r"(kernel_entry));
+        // Switch to the INSTRUCTIONS local memory space 
+        // to avoid contention at the boot cluster.
+        asm volatile("mtc2  %0, $25" :: "r"(cxy));
+
+        // Get local boot_info_t structure base address.
+        boot_info = (boot_info_t *)seg_kdata_base;
+
+        // Check core information
+        boot_check_core(boot_info, lid);
+
+        // Wait until all local cores in cluster ready
+        boot_remote_barrier( XPTR( cxy , &local_barrier ) , boot_info->cores_nr );
+    }
+
+    // Each core compute address of a temporary kernel stack 
+    // in the upper part of the local cluster memory...
+    uint32_t stack_ptr = ((boot_info->pages_nr - lid) << 12) - 16;
+
+    // All cores initialise stack pointer,
+    // reset the BEV bit in status register,
+    // register "boot_info" argument in a0,
+    // and jump to kernel_entry. 
+    asm volatile( "mfc0  $27,  $12           \n"
+                  "lui   $26,  0xFFBF        \n"
+                  "ori   $26,  $26,  0xFFFF  \n"
+                  "and   $27,  $27,  $26     \n"
+                  "mtc0  $27,  $12           \n" 
+                  "move  $4,   %0            \n"
+                  "move  $29,  %1            \n"
+                  "jr    %2                  \n"
+                  :: "r"(boot_info) , "r"(stack_ptr) , "r"(kernel_entry) );
 
 } // boot_loader()
Index: trunk/tools/bootloader_tsar/boot_bdv_driver.c
===================================================================
--- trunk/tools/bootloader_tsar/boot_bdv_driver.c	(revision 1)
+++ trunk/tools/bootloader_tsar/boot_bdv_driver.c	(revision 6)
@@ -12,9 +12,17 @@
 
 #ifndef SEG_IOC_BASE
-# error "The SEG_IOC_BASE value should be defined in the 'boot_config.h' file"
+# error "The SEG_IOC_BASE value should be defined in the 'hard_config.h' file"
 #endif
 
-#ifndef IO_CXY
-# error "The IO_CXY value should be defined in the 'boot_config.h' file"
+#ifndef X_IO
+# error "The X_IO value should be defined in the 'hard_config.h' file"
+#endif
+
+#ifndef Y_IO
+# error "The Y_IO value should be defined in the 'hard_config.h' file"
+#endif
+
+#ifndef Y_WIDTH
+# error "The Y_WIDTH value should be defined in the 'hard_config.h' file"
 #endif
 
@@ -31,5 +39,5 @@
 static uint32_t boot_bdv_get_register( uint32_t reg )
 {
-    cxy_t      cxy = IO_CXY;
+    cxy_t      cxy = (X_IO << Y_WIDTH) + Y_IO;
     uint32_t * ptr = (uint32_t *)SEG_IOC_BASE + reg;
     
@@ -46,5 +54,5 @@
                                    uint32_t val )
 {
-    cxy_t      cxy = IO_CXY;
+    cxy_t      cxy = (X_IO << Y_WIDTH) + Y_IO;
     uint32_t * ptr = (uint32_t *)SEG_IOC_BASE + reg;
 
